; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518;400
Texture struct
	imageData dd ?; Image Data (Up To 32 Bits)
	bpp	dd ?; Image Color Depth In Bits Per Pixel
	width_	dd ?; Image Width
	height	dd ?; Image Height
	texID	dd ?; Texture ID Used To Select A Texture
	type_	dd ?; Image Type (GL_RGB, GL_RGBA)	
Texture ends

TGAHeader struct
 Header db 12 dup(?);		 TGA File Header
TGAHeader ends

TGA struct
	header		db 6 dup(?); First 6 Useful Bytes From The Header
	bytesPerPixel	dd ?;	 Holds Number Of Bytes Per Pixel Used In The TGA File
	imageSize	dd ?;	 Used To Store The Image Size When Setting Aside Ram
	temp		dd ?;	 Temporary Variable
	type_		dd ?;
	Height		dd ?;	Height of Image
	Width_		dd ?;	Width ofImage
	Bpp		dd ?;	 Bits Per Pixel
TGA ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	hFile:dword
local	FSize:dword
local	pMemory1:dword
local	pMemory2:dword
local	szReadWrite:dword
local	txt:dword
local	cnt:dword

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL

wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_UP
	jne	@f
	cmp	scroll,0
	jle	wmBYE
	sub	scroll,2
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	wmBYE
	mov	eax,maxtokens
	sub	eax,9
	shl	eax,5
	cmp	scroll,eax
	jae	wmBYE
	add	scroll,2
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------
	mov	ecx,offset FileName1
        invoke	CreateFile,,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,rbx,rbx
	mov	hFile,eax
        invoke	GetFileSize,eax,0
        inc	eax
	mov	FSize,eax
        invoke	GlobalAlloc,GPTR,eax
        mov	pMemory1,eax
	mov	r8d,FSize
	dec	r8d
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,,,rbx
	invoke	CloseHandle,hFile
	mov	esi,offset uTGAcompare
	mov	edi,pMemory1
	mov	ecx,3
        repe	cmpsd
        jnz	@f
	mov	ecx,pMemory1
	invoke	LoadUncompressedTGA
@@:
	lea	edx,texture.texID
	invoke	glGenTextures,1; Create The Texture ( CHANGE )

	mov	edx,texture.texID
	invoke	glBindTexture,GL_TEXTURE_2D
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR

	mov	r8d,texture.type_
	mov	r9d,texture.width_
	mov	eax,texture.height
	mov	[rsp+20h],rax
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	eax,texture.imageData
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,0,,,,rdx,r8

	mov	ecx,texture.imageData
	invoke	GlobalFree

	invoke	BuildFont;				Build The Font

	invoke	glShadeModel,GL_SMOOTH	; Enable Smooth Shading
	movss	xmm3,const0_5
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor;(0.0f, 0.0f, 0.0f, 0.5f); Black Background
	cvtss2sd xmm0,const1
	invoke	glClearDepth	; Depth Buffer Setup
	mov	edx,texture.texID
	invoke	glBindTexture,GL_TEXTURE_2D;		// Select Our Font Texture

        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	xorps	xmm3,xmm3
	movsd	xmm2,constd480
	movsd	xmm1,constd640
	xorps	xmm0,xmm0
	invoke	glOrtho,,,,,constd_1,constd1; Create Ortho 640x480 View (0,0 At Top Left)
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	and	cnt,0

	movss	xmm2,const0_5
	movss	xmm1,xmm2
	movss	xmm0,const1
	invoke	glColor3f;1,0.5,0.5	Set Color To Bright Red
	mov	r9d,offset aRenderer
	invoke	glPrint,50,16,1;Display Renderer
	mov	r9d,offset aVendor
	invoke	glPrint,80,48,1;	Display Vendor Name
	mov	r9d,offset aVersion
	invoke	glPrint,66,80,1;	Display Version
	movss	xmm2,const0_4
	movss	xmm1,const0_7
	movss	xmm0,const1
	invoke	glColor3f;1,0.7,0.4	Set Color To Orange
	invoke	glGetString,GL_RENDERER
	invoke	glPrint,200,16,1,eax; Display Renderer
	invoke	glGetString,GL_VENDOR
	invoke	glPrint,200,48,1,eax; Display Vendor Name
	invoke	glGetString,GL_VERSION
	invoke	glPrint,200,80,1,eax; Display Version
 
	movss	xmm2,const1
	movss	xmm1,const0_5
	movss	xmm0,xmm1
	invoke	glColor3f;0.5,0.5,1	Set Color To Bright Blue
	mov	r9d,offset aNeHe_Productions
	invoke	glPrint,192,432,1; Write NeHe Productions At The Bottom Of The Screen
 
	invoke	glLoadIdentity;			Reset The ModelView Matrix
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;1,1,1	Set The Color To White
	invoke	glBegin,GL_LINE_STRIP;		Start Drawing Line Strips (Something New)
 
	movsd	xmm1,constd417
	movsd	xmm0,constd639
	invoke	glVertex2d;(639,417);	Top Right Of Bottom Box
	movsd	xmm1,constd417
	xorps	xmm0,xmm0
	invoke	glVertex2d;(  0,417);	Top Left Of Bottom Box
	movsd	xmm1,constd480
	xorps	xmm0,xmm0
	invoke	glVertex2d;(  0,480);	Lower Left Of Bottom Box
	movsd	xmm1,constd480
	movsd	xmm0,constd639
	invoke	glVertex2d;(639,480);	Lower Right Of Bottom Box
	movsd	xmm1,constd128
	movsd	xmm0,constd639
	invoke	glVertex2d;(639,128);	Up To Bottom Right Of Top Box
	invoke	glEnd;					Done First Line Strip

	invoke	glBegin,GL_LINE_STRIP;		Start Drawing Another Line Strip
	movsd	xmm1,constd126;8
	xorps	xmm0,xmm0
	invoke	glVertex2d;(  0,128);	Bottom Left Of Top Box
	movsd	xmm1,constd126;8
	movsd	xmm0,constd639
	invoke	glVertex2d;(639,128);	Bottom Right Of Top Box								
	movsd	xmm1,constd1
	movsd	xmm0,constd639
	invoke	glVertex2d;(639,  1);	Top Right Of Top Box
	movsd	xmm1,constd1
	xorps	xmm0,xmm0
	invoke	glVertex2d;(  0,  1);	Top Left Of Top Box
	movsd	xmm1,constd417
	xorps	xmm0,xmm0
	invoke	glVertex2d;(  0,417);	Down To Top Left Of Bottom Box
	invoke	glEnd;		Done Second Line Strip

	movss	xmm0,sheight
	mulss	xmm0,const0_597916
	cvtss2si r9d,xmm0
	mov	r8d,swidth
	sub	r8d,2
	movss	xmm0,sheight
	mulss	xmm0,const0_135416
	cvtss2si edx,xmm0
	invoke	glScissor,1; Define Scissor Region
	invoke	glEnable,GL_SCISSOR_TEST;	Enable Scissor Testing
	invoke	glGetString,GL_EXTENSIONS
	inc	eax
	invoke	strlen,eax
        invoke	GlobalAlloc,GPTR,eax
	mov	txt,eax; Allocate Memory For Our Extension String
	invoke	glGetString,GL_EXTENSIONS
	mov	ecx,txt
	invoke	strcpy,,eax; Grab The Extension List, Store In Text
	mov	edx,offset aSpace;" "
	mov	ecx,txt
	invoke	strtok;		Parse 'text' For Words, Seperated By " " (spaces)
	mov	token,eax
	or	eax,eax
	jz	@1;while(token!=NULL)	While The Token Isn't NULL
@3:	inc	cnt;		Increase The Counter
	mov	eax,maxtokens
	cmp	cnt,eax;		Is 'maxtokens' Less Than 'cnt'
	jbe	@f
	mov	eax,cnt
	mov	maxtokens,eax;		If So, Set 'maxtokens' Equal To 'cnt'

@@:	movss	xmm2,const0_5
	movss	xmm1,const1
	movss	xmm0,xmm2
	invoke	glColor3f;0.5,1,0.5	Set Color To Bright Green
	mov	edx,cnt
	mov	[rsp+20h],rdx
	shl	edx,5
	add	edx,96
	sub	edx,scroll
	mov	r9d,offset _i
	invoke	glPrint,0,,0; Print Current Extension Number
	movss	xmm2,const0_5
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glColor3f;1,1,0.5	Set Color To Yellow
	mov	r9d,token
	mov	edx,cnt
	shl	edx,5
	add	edx,96
	sub	edx,scroll
	invoke	glPrint,50,,0;	Print The Current Token (Parsed Extension Name)
	mov	edx,offset aSpace
	invoke	strtok,NULL
	mov	token,eax;	Search For The Next Token
	or	eax,eax
	jnz	@3

@1:	invoke	glDisable,GL_SCISSOR_TEST;Disable Scissor Testing
	mov	ecx,txt
	invoke	GlobalFree;Free Allocated Memory

	invoke	glFlush;Flush The Rendering Pipeline

;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn
WndProc	endp
LoadUncompressedTGA proc textur:dword;, char * filename, FILE * fTGA)	// Load an uncompressed TGA (note, much of this code is based on NeHe's 
local	bytesPerPixel:dword
local	imageSize:dword

	mov	textur,ecx
	push	rsi
	push	rdi
	add	ecx,sizeof TGAHeader
	movzx	eax,word ptr [rcx]
	mov	texture.width_,eax
	movzx	eax,word ptr [rcx+2]
	mov	texture.height,eax
	movzx	eax,byte ptr [rcx+4]
	mov	texture.bpp,eax
	shr	eax,3
	mov     bytesPerPixel,eax
	cmp	eax,3
	je	@f
	mov	texture.type_,GL_RGBA
	jmp	@0
@@:     mov	texture.type_,GL_BGR_EXT
@0:	mul	texture.width_
	mul	texture.height
	mov	imageSize,eax
        invoke	GlobalAlloc,GPTR,eax
	mov	texture.imageData,eax
	mov	edi,eax
	mov	esi,textur
	add	esi,sizeof TGAHeader+6
	mov	ecx,imageSize
	shr	ecx,3
	rep	movsq
	mov	ecx,textur
	invoke	GlobalFree
	pop	rdi
	pop	rsi
	leave
	ret
LoadUncompressedTGA endp
BuildFont proc
local	cx_:dword
local	cy:dword

	invoke	glGenLists,256;	 Creating 256 Display Lists
	mov	base,eax
	mov	edx, texture.texID
	invoke	glBindTexture,GL_TEXTURE_2D; Select Our Font Texture
	xor	esi,esi;loop1=0; loop1<256; loop1++)	 Loop Through all 256 Lists
@@:	mov	eax,esi
	and	eax,15;esi%16
	mov	edx,esi
	shr	edx,4;esi/16
	cvtsi2ss xmm0,eax
	divss	xmm0,const16
	movd	cx_,xmm0;cx=(loop1%16)/16.0 X position of current character
	cvtsi2ss xmm0,edx
	divss	xmm0,const16
	movd	cy,xmm0;cy=(loop1%16)/16.0 Y position of current character
	mov	ecx,base
	add	ecx,esi
	invoke	glNewList,,GL_COMPILE; Start Building a List
;	{
;		float cx=float(loop1%16)/16.0f; X Position Of Current Character
;		float cy=float(loop1/16)/16.0f; Y Position Of Current Character
 ;
;		glNewList(base+loop1,GL_COMPILE); Start Building A List
	invoke	glBegin,GL_QUADS; Use a Quad for Each character
	movd	xmm1,const1
	subss	xmm1,cy
	subss	xmm1,const0_0625
	movd	xmm0,cx_
	invoke	glTexCoord2f;cx,1-cy-0.0625 Texture Coord (Bottom Left)
;			glBegin(GL_QUADS); Use A Quad For Each Character
;				glTexCoord2f(cx,1.0f-cy-0.0625f); Texture Coord (Bottom Left)
	movq	xmm1,constd16
	xorps	xmm0,xmm0
	invoke	glVertex2d;0,16; Vertex Coord (Bottom Left)
;				glVertex2d(0,16); Vertex Coord (Bottom Left)
	movd	xmm1,const0_9375;=1-0.0625
	subss	xmm1,cy
	movd	xmm0,cx_
	addss	xmm0,const0_0625
	invoke	glTexCoord2f;cx+0.0625,1-cy-0.0625 Texture Coord (Bottom Right)
;				glTexCoord2f(cx+0.0625f,1.0f-cy-0.0625f); Texture Coord (Bottom Right)
	invoke	glVertex2i,16,16; Vertex Coord (Bottom Right)
;				glVertex2i(16,16); Vertex Coord (Bottom Right)
	movd	xmm1,const1
	subss	xmm1,cy
	movd	xmm0,cx_
	addss	xmm0,const0_0625
	invoke	glTexCoord2f;cx+0.0625,1-cy Texture Coord (Top Right)
;				glTexCoord2f(cx+0.0625f,1.0f-cy-0.001f); Texture Coord (Top Right)
	invoke	glVertex2i,16,0; Vertex Coord (Top Right)
;				glVertex2i(16,0); Vertex Coord (Top Right)
	movd	xmm1,const1
	subss	xmm1,cy
	movd	xmm0,cx_
	invoke	glTexCoord2f;cx,1-cy Texture Coord (Top Left)
;				glTexCoord2f(cx,1.0f-cy-0.001f); Texture Coord (Top Left)
	invoke	glVertex2i,0,0; Vertex Coord (Top Left)
;				glVertex2i(0,0); Vertex Coord (Top Left)
	invoke	glEnd; Done Building Our Quad (character)
;			glEnd();	Done Building Our Quad (Character)
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movq	xmm0,constd14
	invoke	glTranslated;14,0,0 move to the Right of the character
;			glTranslated(14,0,0); Move To The Right Of The Character
	invoke	glEndList; Done Building the Display List
	inc	esi; Loop Until all 256 are Built
	cmp	esi,256
	jb	@b
;		glEndList();										// Done Building The Display List
;	}; Loop Until All 256 Are Built
	leave
	ret
BuildFont endp
glPrint proc x:dword, y:dword, set:dword, fmt:dword,params:VARARG; Where The Printing Happens
local	buff[1024]:byte; Holds Our String
local	len:dword

	mov	x,ecx
	mov	y,edx
	mov	set,r8d
	mov	fmt,r9d

	or	r9d,r9d;if (fmt == NULL); ᫨  ⥪
	jz	@0; 室
	lea	r8d,params
	mov	edx,r9d;fmt
	lea	ecx,buff
	invoke	vsprintf;(buff, fmt, ap); And Converts Symbols To Actual Numbers
	mov	len,eax; Results Are Stored In Text
	cmp	set,1;᫨ ࠭    ᨬ?
	jna	@f	
	mov	set,1;᫨ ⠪,    1 (ᨢ)
@@:	invoke	glEnable,GL_TEXTURE_2D; Enable Texture Mapping
	invoke	glLoadIdentity; Reset The Modelview Matrix
	xorps	xmm2,xmm2
	cvtsi2sd xmm1,y
	cvtsi2sd xmm0,x
	invoke	glTranslated;(x,y,0; Position The Text (0,0 - Top Left)
;(base-32+(128*set)); Choose The Font Set (0 or 1)
	mov	ecx,set
	shl	ecx,7
	add	ecx,base
	sub	ecx,32
	invoke	glListBase
	movss	xmm2,const1
	movss	xmm1,const2
	movss	xmm0,xmm2
	invoke	glScalef;1,2,1	Make The Text 2X Taller
	mov	ecx,len
	lea	r8d,buff
	invoke	glCallLists,,GL_UNSIGNED_BYTE; Write The Text To The Screen
	invoke	glDisable,GL_TEXTURE_2D; Disable Texture Mapping
@0:	leave
	ret
glPrint endp
;------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	24;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #24: Token, Extensions, Scissoring & TGA Loading Tutorial",0
FileName	db "br_Rabbit3.cur",0
FileName1	db "Font.tga",0
aRenderer	db "Renderer",0;Display Renderer
aVendor		db "Vendor",0;	Display Vendor Name
aVersion	db "Version",0
aNeHe_Productions db "NeHe Productions",0
uTGAcompare	db 0,0,2, 9 dup(0); Uncompressed TGA Header
texture 	Texture <>
token		dd ?
sheight		dd ?
swidth		dd ?
scroll		dd ?
_i		db "%i",0
base		dd ?
aSpace		db " ",0
maxtokens	dd ?; Keeps Track Of The Number Of Extensions Supported
;-----------------------------
;float
const0_05	dd 0.05
const0_0625	dd 0.0625
const0_135416	dd 0.135416
const0_4	dd 0.4
const0_5	dd 0.5
const0_597916	dd 0.597916
const0_7	dd 0.7
const0_9375	dd 0.9375
const1		dd 1.0
const_1		dd -1.0
const2		dd 2.0
const_2		dd -2.0
const_10	dd -10.0
const16		dd 16.0
const18		dd 18.0
const36		dd 36.0
;double
constd1		dq 1.0
constd_1	dq -1.0
constd14	dq 14.0
constd16	dq 16.0
constd45	dq 45.0
constd100	dq 100.0
constd126	dq 126.0
constd128	dq 128.0
constd417	dq 417.0
constd480	dq 480.0
constd639	dq 639.0
constd640	dq 640.0
end